#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "convex"

const int MaxN = 100;

int x [MaxN], y [MaxN], ans [MaxN];
int n, len;

int vp (int x0, int y0, int x1, int y1, int x2, int y2)
{
 return (x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0);
}

int main (void)
{
 int i, j, k, l;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= 3 && n <= 100);
  for (i = 0; i < n; i++)
  {
   scanf (" %d %d", &x[i], &y[i]);
   assert (x[i] >= -1000 && x[i] <= 1000);
   assert (y[i] >= -1000 && y[i] <= 1000);
  }
  l = 0;
  for (i = 1; i < n; i++)
   if (x[i] < x[l] || x[i] == x[l] && y[i] < y[l])
    l = i;
  k = l;
  len = 0;
  do
  {
   j = k;
   k = !j;
   for (i = 1; i < n; i++) if (i != j)
    if (vp (x[j], y[j], x[k], y[k], x[i], y[i]) > 0)
     k = i;
   ans[len] = j;
   len++;
  }
  while (k != l);
  printf ("%d\n", len);
  for (i = 0; i < len; i++)
   printf ("%d %d\n", x[ans[i]], y[ans[i]]);
 }
 return 0;
}
