#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "double"

const int MaxN = 100005, Prime = 821, MaxHash = 1 << 20, AndHash = MaxHash - 1;

char s [MaxN];
int h [MaxHash];
int n, k;

int main (void)
{
 int i, ch, p;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %s", s) != EOF)
 {
  scanf (" %d", &k);
  n = strlen (s);
  assert (n >= 1 && n <= 100000);
  assert (k >= 1 && k <= n);
  memset (h, 0, sizeof (h));
  ch = 0;
  p = 1;
  for (i = 0; i < k; i++)
  {
   ch = ch * Prime + s[i];
   p *= Prime;
  }
  for (assert (i == k); i < n; i++)
  {
   ch &= AndHash;
   if (h[ch]) break;
   h[ch]++;
   ch = ch * Prime + s[i] - p * s[i - k];
  }
  if (i == n)
   printf ("NONE\n");
  else
  {
   s[i] = '\0';
   printf ("%s\n", &s[i - k]);
  }
 }
 return 0;
}
