#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "double"

const int MaxN = 100005, Prime1 = 821, Prime2 = 262139,
 MaxHash = 1 << 23, AndHash1 = MaxHash - 1, AndHash2 = 0x7FFFFFFF;

char s [MaxN];
int h [MaxHash];
int n, k;

int main (void)
{
 int i, ch1, ch2, ptr, p1, p2;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %s", s) != EOF)
 {
  scanf (" %d", &k);
  n = strlen (s);
  assert (n >= 1 && n <= 100000);
  assert (k >= 1 && k <= n);
  memset (h, -1, sizeof (h));
  ch1 = 0;
  p1 = 1;
  ch2 = 0;
  p2 = 1;
  for (i = 0; i < k; i++)
  {
   ch1 = ch1 * Prime1 + s[i];
   p1 *= Prime1;
   ch2 = ch2 * Prime2 + s[i];
   p2 *= Prime2;
  }
  for (assert (i == k); i < n; i++)
  {
   ptr = ch1 & AndHash1;
   ch2 &= AndHash2;
   while (h[ptr] != -1 && h[ptr] != ch2) ptr = (ptr + 1) & AndHash1;
   if (h[ptr] == ch2) break;
   h[ptr] = ch2;
   ch1 = ch1 * Prime1 + s[i] - p1 * s[i - k];
   ch2 = ch2 * Prime2 + s[i] - p2 * s[i - k];
  }
  if (i == n)
   printf ("NONE\n");
  else
  {
   s[i] = '\0';
   printf ("%s\n", &s[i - k]);
  }
 }
 return 0;
}
